(provide 'syntenv)
(require 'lib)

"
Syntactic environments:
* a source environment is a symbol -> object binder.
* a target environment accepts new symbol -> object bindings.

"

; Syntactic Environment
; implemented as a particular case of association tables,
; where the key is a symbol


; Syntactic environment
(define syntenv:nil (list assoc:nil))
(define (syntenv:cons x v env)
    (cons (assoc:cons x v (car env)) (cdr env)))
(define syntenv:lookup assoc:lookup)
(define syntenv:find assoc:find)
(define syntenv:join assoc:merge)


; Stuff associated to symbols:
; VALUE (quote-pattern)
; PATTERN
; SPECIAL-PATTERN -> constructing and deconstructing functions

