;--------------------------------- ansic.scm ---------------------------------
;   This is the .scm include file that defines enough stuff so that
; C is turned into an instance of our generic assembler.


(provide 'ansic)
(require 'langc)
(require 'libc)





;;;;;;;;;;;;;;;;;;;;;;;;; Defining FORTH words ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
"
;; defining a counted string
(define DefCString},
{*stringseg*({
locals({strlen},{strbeg},{strend},{
strbeg:
	.byte 	strlen
	defb($@)
strend:
strlen	=	strend-strbeg-1
})})})
"

;; defining a FORTH word

(define (vp:define-label name Cname LLLname)
   (C:label (vp:name name Cname LLLname)))


(define (define-comparison-to-0-primite name Cname LLLname operator)
   (vp:define-primitive name x y
     (vp:Enter)
     (C:set! 'TOS `(? (,operator TOS 0) FALSE TRUE))
     (vp:Next)))

(define (define-comparison-primitive name Cn Ln operator)
   (vp:define-primitive name x y
     (vp:Enter)
     (C:set! 'TOS `(? (,operator NOS TOS) FALSE TRUE))
     (vp:Nip)
     (vp:Next)))
